/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation			 *
 * Copyright (c) 2000 by Myricom, Inc.					 *
 * All rights reserved.	 See the file `COPYING' for copyright notice.	 *
 *************************************************************************/

/* author: glenn@myri.com */

#ifndef _gm_dma_chain_h_
#define _gm_dma_chain_h_

#include "gm.h"
#include "gm_simple_types.h"

typedef struct gm_dma_descriptor {
  gm_lp_n_t next_with_flags;	/* next pointer */
  gm_u16_n_t csum[2];	/* 2 16-bit ones complement checksums of this block */
  /* 8 */
  gm_u32_n_t len;		/* byte count */
  gm_lp_n_t lanai_addr;		/* lanai address */
  /* 8 */
  gm_u32_n_t ebus_addr_high;
  gm_u32_n_t ebus_addr_low;
} gm_dma_descriptor_t;

#if GM_MCP

#define GM_DMA_DESCRIPTOR_L2E		0x0
#define GM_DMA_DESCRIPTOR_E2L		0x1
#define GM_DMA_DESCRIPTOR_DIR		0x1 /* mask to extract direction */
#define GM_DMA_DESCRIPTOR_TERMINAL	0x2 /* terminal block? */
#define GM_DMA_DESCRIPTOR_WAKE		0x4 /* wake when block completes */
#define GM_DMA_DESCRIPTOR_FLAG_MASK	0x7

static inline
gm_size_t
GM_DMA_DESCRIPTOR_NEXT_WITH_FLAGS_FLAGS (gm_lp_t next_with_flags)
{
  return ((gm_size_t) next_with_flags);
}

static inline
gm_dma_descriptor_t *
GM_DMA_DESCRIPTOR_NEXT_WITH_FLAGS_PTR (gm_lp_t next_with_flags)
{
  return ((gm_dma_descriptor_t *)
	  ((gm_size_t) next_with_flags
	   & ~(gm_size_t) GM_DMA_DESCRIPTOR_FLAG_MASK));
}

static inline
gm_lp_t
GM_DMA_DESCRIPTOR_BUILD_NEXT_WITH_FLAGS (gm_dma_descriptor_t *next,
					 int flags)
{
  return (gm_lp_t) ((char *) next + flags);
}

#endif /* GM_MCP */
#endif /* _gm_dma_chain_h_ */
