/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation			 *
 * Copyright (c) 2000 by Myricom, Inc.					 *
 * All rights reserved.	 See the file `COPYING' for copyright notice.	 *
 *************************************************************************/

/* author: glenn@myri.com */

#ifndef _gm_alarm_h_
#define _gm_alarm_h_

#include "gmcp.h"

static inline void
gm_unset_alarm (gm_port_protected_lanai_side_t * port)
{
  gm_port_protected_lanai_side_t **pp;

  if (!port->alarm_set)
    return;

  for (pp = &gm.first_port_with_alarm; *pp; pp = &(*pp)->next_with_alarm)
    {
      if (*pp == port)
	{
	  *pp = port->next_with_alarm;
	  break;
	}
    }
  port->alarm_set = 0;
}

static inline void
gm_lanai_set_alarm (gm_port_protected_lanai_side_t * port, gm_s32_t time)
{
  /* BAD: Should sort alarms by time */

  port->next_with_alarm = gm.first_port_with_alarm;
  gm.first_port_with_alarm = port;
  port->alarm_time = time;	/* the "tick" time is .5 microseconds */
  port->alarm_set = 1;
}

#endif /* _gm_alarm_h_ */
