/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation			 *
 * Copyright (c) 2001 by Myricom, Inc.					 *
 * All rights reserved.	 See the file `COPYING' for copyright notice.	 *
 *************************************************************************/

/* author: glenn@myri.com */

#include "gm_chained_dma.h"

int gm_chained_dma_initialized;
gm_dma_descriptor_t *gm_chained_dma_free_descriptor;

int
gm_dma_chain_ok (void)
{
  unsigned int i;
  
  for (i=0;
       i < GM_NUM_ELEM (gm.user_dma_descriptor);
       i++)
    {
      gm_dma_descriptor_t *a;
      gm_dma_descriptor_t *b;
      
      a = &gm.user_dma_descriptor[i];
      if (i+1 == GM_NUM_ELEM (gm.user_dma_descriptor))
	{
	  b = &gm.user_dma_descriptor[0];
	}
      else
	{
	  b = &gm.user_dma_descriptor[i+1];
	}

      if (GM_DMA_DESCRIPTOR_NEXT_WITH_FLAGS_PTR (a->next_with_flags) != b)
	{
	  return 0;
	}
    }
  return 1;
}

gm_status_t
gm_chained_dma_initialize (void)
{
  unsigned int i;

  GM_DEBUG_CHAINED_DMA_ASSERT (GM_NUM_ELEM (gm.user_dma_descriptor)
			       == GM_MAX_NUM_DMA_SEGMENTS + 1);
  
  for (i=0; i<GM_NUM_ELEM(gm.user_dma_descriptor); i++)
    {
      gm.user_dma_descriptor[i].next_with_flags
	= (GM_DMA_DESCRIPTOR_BUILD_NEXT_WITH_FLAGS
	   (&gm.user_dma_descriptor[i+1], GM_DMA_DESCRIPTOR_TERMINAL));
    }
  gm.user_dma_descriptor[GM_NUM_ELEM(gm.user_dma_descriptor)-1].next_with_flags
    = (GM_DMA_DESCRIPTOR_BUILD_NEXT_WITH_FLAGS
       (&gm.user_dma_descriptor[0], GM_DMA_DESCRIPTOR_TERMINAL));
  gm_chained_dma_free_descriptor = &gm.user_dma_descriptor[0];
  gm_chained_dma_initialized = 1;
  GM_DEBUG_CHAINED_DMA_ASSERT (gm_dma_chain_ok ());
  return GM_SUCCESS;
}

/*
  This file uses GM standard indentation.

  Local Variables:
  c-file-style:"gnu"
  tab-width:8
  End:
*/
