/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation			 *
 * Copyright (c) 2000 by Myricom, Inc.					 *
 * All rights reserved.	 See the file `COPYING' for copyright notice.	 *
 *************************************************************************/

/* author: glenn@myri.com */

#include "gm_connection.h"

/* reset a previously initialized connection */

void
gm_connection_reset (gm_connection_t * c)
{
  gm_always_assert (c);

  c->send_sexno.parts.sesno = 0;
  c->send_sexno.parts.seqno = 1;

  gm_always_assert (c->ack_packet.type == GM_PACKET_TYPE);

  c->ack_packet.subtype = GM_ACK_SUBTYPE;
  c->ack_packet.sexno.whole = 0;

  gm_always_assert (c->ack_packet.sender_node_id == gm.this_node_id);

#if 0
  c->first_active_send_port = 0;
#endif

  gm_always_assert (c->first_send_record == 0);

  c->open_time = rtc64 () - GM_CONNECTION_TIMEOUT - 1;
  c->close_time = rtc64 () - GM_CONNECTION_TIMEOUT - 1;
}

/* initialize a bzero'd connection */

void
_gm_connection_init (gm_connection_t * c)
{
  gm_always_assert ((GM_PORT != 0));
  gm_always_assert ((unsigned int) (c + 1) <= (unsigned int) &GM_PORT[0]);

  c->next_active = 0;
  c->prev_active = 0;
  GM_CONNECTION_CLEAR_ROUTE (c);
  /* c->ack_pending = 0; */
  /* c->next_to_ack = 0; */
  /* Force sequence number mismatch to cause connection reset to
     be detected. */
  /* c->send_sexno.parts.sesno = 0; */
  c->send_sexno.parts.seqno = 1;
  /* c->route = 0; */

  c->ack_packet.type = GM_PACKET_TYPE;
  c->ack_packet.subtype = GM_ACK_SUBTYPE;
  /* c->ack_packet.sexno.whole = 0; */
  c->ack_packet.target_node_id = c - &gm_connection[0];
  /* We don't know gm.this_node_id yet, so this just sets it to 0: */
  c->ack_packet.sender_node_id = gm.this_node_id;

  /* c->active_subport_bitmask = 0; */
  /* c->first_active_send_port = 0; */
  /* c->first_send_record = 0; */
  /* c->last_send_record = 0; */
  {
    const gm_u64_t one = 1;
    c->open_time = rtc64 () - (one << 32);
    c->close_time = rtc64 () - (one << 32);
  }
}
