/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation			 *
 * Copyright (c) 2000 by Myricom, Inc.					 *
 * All rights reserved.	 See the file `COPYING' for copyright notice.	 *
 *************************************************************************/

/* author: glenn@myri.com */

#ifndef _gm_control_packet_h_
#define _gm_control_packet_h_

#include "gm.h"
#include "gm_types.h"

static inline
int
gm_is_control_packet (gm_packet_header_t *h)
{
  gm_u32_t type_subtype;
  gm_u32_t mask;
  gm_u32_t match;

  gm_assert (GM_ACK_SUBTYPE == 0x80);
  
  type_subtype = * (gm_u32_t *) h;
  mask = 0xffff0080;
  match = (GM_PACKET_TYPE << 16) | 0x80;
  
  return (type_subtype & mask) == match;
}

void gm_handle_control_packet (gm_packet_header_t *p);


#endif _gm_control_packet_h_
