/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation                      *
 * Copyright (c) 1996, 1997, 2002 by Myricom, Inc.                       *
 * All rights reserved.  See the file `COPYING' for copyright notice.    *
 *************************************************************************/

/* author: glenn@myri.com */

#include "gmcp.h"
#include "gm_dispatch.h"

#ifndef FAIR
#define FAIR(DO_INDEX,MY_INDEX,NEXT_STATE) do {				\
  gm_handler_t handler = GET_HANDLER (DO_INDEX);			\
  GM_HANDLER_CALLED ();							\
  SET_HANDLER (MY_INDEX, NEXT_STATE, );					\
  LOG_DISPATCH (0, "");						\
  GOTO_PREFETCHED_HANDLER (handler);					\
} while (0)
#endif


/***************************
** Fairness state machine **
***************************/


/************
 * sdma rdma
 ************/

void
fair__sdma_rdma_0 (void)
{
  FAIR (START_SDMA_EVENT, FAIR_SDMA_RDMA_EVENT, fair__sdma_rdma_1);
}

void
fair__sdma_rdma_1 (void)
{
  FAIR (START_RDMA_EVENT, FAIR_SDMA_RDMA_EVENT, fair__sdma_rdma_2);
}

void
fair__sdma_rdma_2 (void)
{
  FAIR (POLL_EVENT, FAIR_SDMA_RDMA_EVENT, fair__sdma_rdma_0);
}

/************
 * sdma
 ************/

void
fair__sdma_0 (void)
{
  FAIR (START_SDMA_EVENT, FAIR_SDMA_EVENT, fair__sdma_1);
}

void
fair__sdma_1 (void)
{
  FAIR (POLL_EVENT, FAIR_SDMA_EVENT, fair__sdma_0);
}

/************
 * rdma
 ************/

void
fair__rdma_0 (void)
{
  FAIR (START_RDMA_EVENT, FAIR_RDMA_EVENT, fair__rdma_1);
}

void
fair__rdma_1 (void)
{
  FAIR (POLL_EVENT, FAIR_RDMA_EVENT, fair__rdma_0);
}

/****************
 * idle
 ****************/

void
idle (void)
{
  GM_HANDLER_CALLED ();
  DISPATCH (7, "");
}


/*
  This file uses GM standard indentation.

  Local Variables:
  c-file-style:"gnu"
  c-backslash-column:72
  tab-width:8
  End:
*/
