/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation			 *
 * Copyright (c) 2000 by Myricom, Inc.					 *
 * All rights reserved.	 See the file `COPYING' for copyright notice.	 *
 *************************************************************************/

/* author: glenn@myri.com */

/* This file optionally debugs the number of subports in the send queue. */

#ifndef _gm_subport_cnt_h_
#define _gm_subport_cnt_h_

#define GM_DEBUG_SEND_QUEUE 0

#if GM_DEBUG_SEND_QUEUE
#warning debugging send queue
#endif

#error
static int gm_debug_send_queue_cnt;
static unsigned int gm_debug_subport_cnt;

static inline void
check_subport_cnt (void)
{
  gm_connection_t *c;
  gm_subport_t *sp;
  unsigned int cnt = 0;

  if (!GM_DEBUG_SEND_QUEUE)
    return;

  c = gm.first_active_connection;
  if (c)
    {
      do
	{
	  sp = c->first_active_send_port;
	  do
	    {
	      cnt++;
	    }
	  while (sp != c->first_active_send_port);

	  c = c->next_active;
	}
      while (c != gm.first_active_connection);
    }
  gm_assert (cnt == gm_debug_subport_cnt);
}

static inline void
incr_subport_cnt (void)
{
  if (GM_DEBUG_SEND_QUEUE)
    {
      gm_printf (GM_STR ("0x%x in send queue after append.\n"),
		 ++gm_debug_send_queue_cnt);
    }
}

static inline void
decr_subport_cnt (void)
{
  if (GM_DEBUG_SEND_QUEUE)
    {
      gm_printf (GM_STR ("0x%x in send queue after remove.\n"),
		 --gm_debug_send_queue_cnt);
    }
}

#endif _gm_subport_cnt_h_
