/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation			 *
 * Copyright (c) 2000 by Myricom, Inc.					 *
 * All rights reserved.	 See the file `COPYING' for copyright notice.	 *
 *************************************************************************/

/* author: glenn@myri.com */

#include "gm_bootstrap.h"
#include "gm_interrupt.h"
#include "gmcp.h"

int _prepared_to_interrupt;

void
_gm_interrupt (gm_u32_t type)
{
  GM_STBAR ();
  gm.interrupt.type = type;
  set_ISR (HOST_SIG_BIT);
#if L7
  /* Writing the HOST_SIG_BIT (or any other _sig_bit) in the LANai7
     can fail, so retry setting it until we succeed.  Check
     gm.interrupt.type to make sure the interrupt was not legitimately
     claimed.  This may seem like overkill at first glance, but
     considering that DMA and Packet Interface traffic can starve the
     LANai CPU, it is necessary to guarantee correct operation. */
  {
    gm_u32_t isr;		/* temp vars for pipelining */

    isr = get_ISR ();
    type = gm.interrupt.type;
    while ((isr & HOST_SIG_BIT) == 0 && type != GM_NO_INTERRUPT)
      {
	set_ISR (HOST_SIG_BIT);
	isr = get_ISR ();
	type = gm.interrupt.type;
      }
  }
#endif
}

void
_gm_interrupt_error (char *error)
{
  char *save;			/* save state during error message interrupt */

  _await_interrupt_completion (__FUNCTION__);
  save = gm.interrupt.print.string;
  gm.interrupt.print.string = error;
  _gm_interrupt (GM_PRINT_INTERRUPT);
  _await_interrupt_completion (__FUNCTION__);
  gm.interrupt.print.string = save;
}
