/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation			 *
 * Copyright (c) 2000 by Myricom, Inc.					 *
 * All rights reserved.	 See the file `COPYING' for copyright notice.	 *
 *************************************************************************/

/* author: glenn@myri.com */

#include "gm_state.h"
#include "gmcp.h"

void
print_state (void)
{
  gm_u32_t state;

  state = (get_ISR () & get_IMR ()) | GM_STATE;

  gm_printf ("ISR =\n"
	  "\t%s %s %s %s\n"
	  "\t%s %s %s %s\n"
	  "\t%s %s %s %s\n"
	  "\t%s %s %s %s\n"
	  "\t%s\n",
	  state & FREE_RECV_CHUNK ? "FREE_RECV_CHUNK" : "free_recv_chunk",
	  state & RECV_INT_BIT ? "RECV_INT_BIT" : "recv_int_bit",
	  state & BUFF_INT_BIT ? "BUFF_INT_BIT" : "buff_int_bit",
	  state & SEND_INT_BIT ? "SEND_INT_BIT" : "send_int_bit",
	  state & SDMA_PENDING ? "SDMA_PENDING" : "sdma_pending",
	  state & TIME_INT_BIT ? "TIME_INT_BIT" : "time_int_bit",
	  state & FREE_SEND_CHUNK ? "FREE_SEND_CHUNK" : "free_send_chunk",
	  state & ACK_PENDING ? "ACK_PENDING" : "ack_pending",
	  state & RDMA_PENDING ? "RDMA_PENDING" : "rdma_pending",
	  state & RDMAING ? "RDMAING" : "rdmaing",
	  state & RECEIVING ? "RECEIVING" : "receiving",
	  state & SENDING ? "SENDING" : "sending",
	  state & SDMAING ? "SDMAING" : "sdmaing",
	  state & SEND_PENDING ? "SEND_PENDING" : "send_pending",
	  state & SDMA_INT_BIT ? "SDMA_INT_BIT" : "sdma_int_bit",
	  state & RDMA_INT_BIT ? "RDMA_INT_BIT" : "rdma_int_bit",
	  state & DMA_INT_BIT ? "DMA_INT_BIT" : "dma_int_bit");
}
