/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation			 *
 * Copyright (c) 2000 by Myricom, Inc.					 *
 * All rights reserved.	 See the file `COPYING' for copyright notice.	 *
 *************************************************************************/

/* author: glenn@myri.com */

#ifndef _gm_state_h_
#define _gm_state_h_

#include "gm_lanai_def.h"
#include "gm.h"

/****************
 * Version-specific state bit definitions
 ****************/

/****
 * L4
 ****/

#if L4
enum gm_state_bits
{
  /* 0x00000001 */ FREE_RECV_CHUNK = BYTE_RDY_BIT,
/* 0x00000002 *//* RECV_INT_BIT */
/* 0x00000004 *//* BUFF_INT_BIT */
/* 0x00000008 *//* SEND_INT_BIT */
/* 0x00000010 *//* DMA_INT_BIT  */
/* 0x00000020 *//* TIME_INT_BIT */
  /* 0x00000040 */ FREE_SEND_CHUNK = WDOG_INT_BIT,
  /* 0x00000080 */ ACK_PENDING = TAIL_INT_BIT,
  /* 0x00000100 */ RDMA_PENDING = OFF_BY_1_BIT,
  /* 0x00000200 */ RDMAING = OFF_BY_2_BIT,
  /* 0x00000400 */ RECEIVING = WAKE_INT_BIT,
  /* 0x00000800 */ SENDING = NRES_INT_BIT,
  /* 0x00001000 */ SDMAING = LINK_INT_BIT,
  /* 0x00002000 */ SEND_PENDING = SEND_RDY_BIT,
  /* 0x00004000 */ SDMA_PENDING = HALF_RDY_BIT,
  /* 0x00008000 */ SDMA_INT_BIT = 0x00008000,
  /* 0x00010000 */ RDMA_INT_BIT = 0x00010000,
};
#define BIGGEST_STATE_BIT	RDMA_INT_BIT

/****
 * L5
 ****/

#  elif L5
enum gm_state_bits
{
  /* 0x00000001 */ FREE_RECV_CHUNK = HEAD_INT_BIT,
/* 0x00000002 *//* RECV_INT_BIT */
/* 0x00000004 *//* BUFF_INT_BIT */
/* 0x00000008 *//* SEND_INT_BIT */
  /* 0x00000010 */ DMA_INT_BIT = (E2L_INT_BIT | L2E_INT_BIT),
/* 0x00000020 *//* TIME_INT_BIT */
  /* 0x00000040 */ RDMA_PENDING = WDOG_INT_BIT,
  /* 0x00000080 */ RDMAING = OFF_BY_1_BIT,
  /* 0x00000100 */ RECEIVING = OFF_BY_2_BIT,
  /* 0x00000200 */ SENDING = OFF_BY_4_BIT,
  /* 0x00000400 */ SDMAING = NRES_INT_BIT,
  /* 0x00000800 */ FREE_SEND_CHUNK = WAKE_INT_BIT,
  /* 0x00001000 */ SEND_PENDING = 0x00002000,
  /* 0x00002000 */ SDMA_PENDING = 0x00004000,
  /* 0x00004000 */ ACK_PENDING = 0x00008000,
  /* 0x00008000 */ SDMA_INT_BIT = 0x00008000,
  /* 0x00010000 */ RDMA_INT_BIT = 0x00010000,
};

#define BIGGEST_STATE_BIT       RDMA_INT_BIT

/****
 * L6
 ****/

#elif L6
enum gm_state_bits
{
  /* 0x00000001 */ FREE_RECV_CHUNK = HEAD_INT_BIT,
/* 0x00000002 *//* RECV_INT_BIT */
/* 0x00000004 *//* BUFF_INT_BIT */
/* 0x00000008 *//* SEND_INT_BIT */
  /* 0x00000010 */ FREE_SEND_CHUNK = LAN8_SIG_BIT,
  /* 0x00000020 */ ACK_PENDING = LAN9_SIG_BIT,
  /* 0x00000040 */ TIME_INT_BIT = TIME0_INT_BIT,
  /* 0x00000080 */ RDMA_PENDING = TIME1_INT_BIT,
  /* 0x00000100 */ RDMAING = OFF_BY_1_BIT,
  /* 0x00000200 */ RECEIVING = OFF_BY_2_BIT,
  /* 0x00000400 */ SENDING = OFF_BY_4_BIT,
  /* 0x00000800 */ SDMAING = NRES_INT_BIT,
/* 0x00001000 *//* DMA_INT_BIT */
  /* 0x00002000 */ SEND_PENDING = TIME2_INT_BIT,
  /* 0x00004000 */ SDMA_PENDING = MEM_INT_BIT,
  /* 0x00008000 */ SDMA_INT_BIT = 0x00008000,
  /* 0x00010000 */ RDMA_INT_BIT = 0x00010000,
};
#define BIGGEST_STATE_BIT	RDMA_INT_BIT

/****
 * L7
 ****/

#elif L7
enum gm_state_bits
{
  /* 0x00000001 */ FREE_RECV_CHUNK = HEAD_INT_BIT,
/* 0x00000002 *//* RECV_INT_BIT */
/* 0x00000004 *//* BUFF_INT_BIT */
/* 0x00000008 *//* SEND_INT_BIT */
  /* 0x00000010 */ FREE_SEND_CHUNK = LAN8_SIG_BIT,
  /* 0x00000020 */ ACK_PENDING = LAN9_SIG_BIT,
  /* 0x00000040 */ TIME_INT_BIT = TIME0_INT_BIT,
  /* 0x00000080 */ RDMA_PENDING = TIME1_INT_BIT,
  /* 0x00000100 */ RDMAING = OFF_BY_1_BIT,
  /* 0x00000200 */ RECEIVING = OFF_BY_2_BIT,
  /* 0x00000400 */ SENDING = OFF_BY_4_BIT,
  /* 0x00000800 */ SDMAING = NRES_INT_BIT,
/* 0x00001000 *//* WAKE_INT_BIT */
  /* 0x00002000 */ SEND_PENDING = TIME2_INT_BIT,
  /* 0x00004000 */ SDMA_PENDING = MEMORY_INT_BIT,
  /* 0x00008000 */ SDMA_INT_BIT = 0x00008000,
  /* 0x00010000 */ RDMA_INT_BIT = 0x00010000,
};

#define BIGGEST_STATE_BIT	RDMA_INT_BIT

/****
 * L8, L9
 ****/

#elif L8 | L9
enum gm_state_bits
{
  /* 0x00000001 */ FREE_RECV_CHUNK = HEAD_INT_BIT,
/* 0x00000002 *//* RECV_INT_BIT */
/* 0x00000004 *//* BUFF_INT_BIT */
/* 0x00000008 *//* SEND_INT_BIT */
  /* 0x00000010 */ FREE_SEND_CHUNK = WAKE1_INT_BIT,
  /* 0x00000020 */ ACK_PENDING = WAKE2_INT_BIT,
  /* 0x00000040 */ TIME_INT_BIT = TIME0_INT_BIT,
  /* 0x00000080 */ RDMA_PENDING = TIME1_INT_BIT,
  /* 0x00000100 */ RDMAING = ORUN1_INT_BIT,
  /* 0x00000200 */ RECEIVING = ORUN2_INT_BIT,
  /* 0x00000400 */ SENDING = ORUN4_INT_BIT,
  /* 0x00000800 */ SDMAING = NRES_INT_BIT,
/* 0x00001000 *//* WAKE0_INT_BIT */
  /* 0x00002000 */ SEND_PENDING = TIME2_INT_BIT,
  /* 0x00004000 */ SDMA_PENDING = MEM_INT_BIT,
  /* 0x00008000 */ SDMA_INT_BIT = 0x00008000,
  /* 0x00010000 */ RDMA_INT_BIT = 0x00010000,
};

#define BIGGEST_STATE_BIT	RDMA_INT_BIT

/****************
 * unrecognized
 ****************/

#else /* L[456789] not defined */
#error LANai version not recognized
#endif

#define IMR_INIT_VAL		(TIME_INT_BIT 				\
				 | DMA_INT_BIT				\
				 | SEND_INT_BIT				\
				 | RECV_INT_BIT				\
				 | BUFF_INT_BIT)

/****************************************************************
 * Prototypes
 ****************************************************************/

void print_state (void);

#endif /* _gm_state_h_ */
