/******************************************************************-*-c-*-
 * Myricom GM networking software and documentation			 *
 * Copyright (c) 2000 by Myricom, Inc.					 *
 * All rights reserved.	 See the file `COPYING' for copyright notice.	 *
 *************************************************************************/

/* author: glenn@myri.com */

#ifndef _gm_state_inlines_h_
#define _gm_state_inlines_h_

#include "gm_state.h"
#include "gm_lanai_globals.h"

extern int state_modified_since_dispatch_offset;

/* Macros for checking state bits using masks above */

#define NOTICED(something)	( GM_STATE&(something))
#define NOTICED_NO(something)	(~GM_STATE&(something))
#define NOTICED_NOT(something)	(~GM_STATE&(something))
#define NOTICED_OR_NOTICED_NOT(a,b) ((GM_STATE^(b))&((a)|(b)))

/* Macros for setting the state using masks above */

static inline void
TOGGLE_STATE (gm_u32_t bits)
{
  GM_STATE ^= bits;
  if (GM_DEBUG)
    {
      state_modified_since_dispatch_offset = 1;
    }
}

static inline void
NOTICE (gm_u32_t bits)
{
  GM_STATE |= bits;
  if (GM_DEBUG)
    {
      state_modified_since_dispatch_offset = 1;
    }
}

static inline void
NOTICE_NO (gm_u32_t bits)
{
  GM_STATE &= ~bits;
  if (GM_DEBUG)
    {
      state_modified_since_dispatch_offset = 1;
    }
}

#define NOTICE_NOT(something)	NOTICE_NO(something)


/* Dispatch debug checks */

static inline void
check_state (gm_u32_t state)
{
  gm_assert (state < (BIGGEST_STATE_BIT << 1));
}

#include "gm_lanai_def.h"

#endif /* _gm_state_inlines_h_ */
