#! /bin/sh

# This is the core command line processing for a /etc/init.d/* script,
# designed to be included by a daemon script.

gm_do test x"$gm_service" != x || gm_die Did not define gm_service above.

# Start a service

gm_start ()
{
    service="$1"
    gm_printf "Starting $service... "
    gm_start_${service}
    if test $? != 0
    then
        echo FAILED.
        return 1
    fi
    echo done.
    return 0
}

# Stop a service

gm_stop ()
{
    service="$1"
    gm_printf "Stopping $service... "
    gm_stop_${service}
    if test $? != 0
    then
        echo FAILED.
        return 1
    fi
    echo done.
    return 0
}

# Parse command line option and execute command
	
case "$1" in
    start)
	gm_start $gm_service
	exit $?
	;;
    stop)
	gm_stop $gm_service
	exit $?
	;;
    restart | force-reload)
	gm_stop $gm_service
	gm_start $gm_service
	exit $?
	;;
    *)
	gm_die Unknown option \""$1"\".
esac

# Never get here

exit 1
