### Modify all #includes of GM files to include the preprocessed version.
### Also, redefine __GM_FILE__ after the inclusion.

/^[ 	]*#[ 	]*include[ 	]*"\(.*\)\.\([ch]\)"/ {
s/^[ 	]*#[ 	]*include[ 	]*"\(.*\)\.\([ch]\)"\(.*\)/#include "\1.\2.\2"\3\
\#undef __GM_FILE__\
\#define __GM_FILE__ "___GM_FILE___"\
\#line /
p
=
d
}

### define __GM_FUNCTION__ at the start of each function

/^[a-zA-Z_][a-zA-Z_0-9]*[ 	]*([^;\\]*$/ {
s/^\([a-zA-Z_][a-zA-Z_0-9]*\)\([ 	]*([^;\\]*\)$/\1\2\
\#undef GM_FUNCTION\
\#define GM_FUNCTION \1\
\#undef __GM_FUNCTION__\
\#define __GM_FUNCTION__ "\1"\
\#line /
p
=
d
}

### Undefine __GM_FUNCTION__ at the end of the function.  This also undefines
### it at the end of any top-level typedefs, but that's OK.

/^}[^\\]*$/ {
s/^\(}[^\\]*\)$/\1\
\#undef GM_FUNCTION\
\#define GM_FUNCTION GM_UNKNOWN_FUNCTION\
\#undef __GM_FUNCTION__\
\#define __GM_FUNCTION__ __GM_UNKNOWN_FUNCTION__\
\#line /
p
=
d
}
